let vm = require('vm');
let Script = vm.Script;
module.exports = (code = $ => $, _globals_ = {}, config = {}) => {
    let $globals = _globals_;
    let globals = {};
    const restrict = [
        "require",
        "process",
        "setTimeout",
        "clearTimeout",
        "setImmediate",
        "clearImmediate",
        "setInterval",
        "clearInterval",
        "console"
    ];
    restrict.forEach(name => globals[name] = typeof ($globals[name]) !== "undefined" ? $globals[name] : undefined);
    globals.Buffer = Buffer;
    globals.exports = {};
    globals._get_ = (name) => {
        return (globals[name]);
    };
    globals._set_ = (name, value) => {
        globals[name] = value;
        return (globals[name]);
    };
    globals = Object.assign({}, globals, $globals);
    globals.__filename = config.filename || globals.__filename || `$_Virtual_File_$`;
    globals.__dirname = config.dirname || globals.__dirname || `$_Virtual_Directory_$`;
    globals.module = {
        exports: globals.exports,
        require: globals.require,
        id: globals.__filename,
        filename: globals.__filename,
        parent: undefined
    };
    let opts = Object.assign({}, {
        filename: globals.__filename,
        dirname: globals.__dirname,
        onError: e => {
            console.log(e);
        },
        displayErrors: true,
        timeout: 1000,
        lineOffset: 0,
        columnOffset: 0,
    }, config);
    if (typeof (code) === "function") {
        code = "\n" + `(${code})();`;
        opts.lineOffset--;
    }
    _globals_[0] = globals;
    globals.global = globals;
    code = `global = new Proxy(global, { get: _get_, set: _set_ });\n${code}`;
    opts.lineOffset--;
    let out = null;
    try {
        out = vm.runInNewContext(code, globals, opts);
    } catch (e) {
        if (!e.stack) { return; }
        e.stack = e.stack.split("    at").splice(0, 2).join("    at");
        e.stack = e.stack.replace(opts.filename, `{x101}`);
        e.stack = e.stack.replace(opts.filename, `${opts.dirname}/${opts.filename}`);
        e.stack = e.stack.replace(`{x101}`, opts.filename);
        opts.onError(e);
    }
    return (out);
};
let vm1 = module.exports;